# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marti_nav_msgs/PlanTrack.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import marti_nav_msgs.msg
import std_msgs.msg

class PlanTrack(genpy.Message):
  _md5sum = "272b3a115ddb82707402b64c92ff6fa0"
  _type = "marti_nav_msgs/PlanTrack"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Gives a position and orientation relative to a position on a plan. Published by position trackers.

std_msgs/Header header                      # only stamp used

string plan_id                              # unique ID of the corresponding plan
geometry_msgs/Pose relative_pose            # pose relative to position on plan
marti_nav_msgs/PlanPosition plan_position   # position on plan

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: marti_nav_msgs/PlanPosition
# Position along a plan. Not typically published by itself.

uint64  index    # index of the nearest point on the plan
float64 distance # forward along route, in meters from point identified by index field
                 # (negative values indicate the distance is backward along the route)
"""
  __slots__ = ['header','plan_id','relative_pose','plan_position']
  _slot_types = ['std_msgs/Header','string','geometry_msgs/Pose','marti_nav_msgs/PlanPosition']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,plan_id,relative_pose,plan_position

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PlanTrack, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.plan_id is None:
        self.plan_id = ''
      if self.relative_pose is None:
        self.relative_pose = geometry_msgs.msg.Pose()
      if self.plan_position is None:
        self.plan_position = marti_nav_msgs.msg.PlanPosition()
    else:
      self.header = std_msgs.msg.Header()
      self.plan_id = ''
      self.relative_pose = geometry_msgs.msg.Pose()
      self.plan_position = marti_nav_msgs.msg.PlanPosition()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.plan_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dQd().pack(_x.relative_pose.position.x, _x.relative_pose.position.y, _x.relative_pose.position.z, _x.relative_pose.orientation.x, _x.relative_pose.orientation.y, _x.relative_pose.orientation.z, _x.relative_pose.orientation.w, _x.plan_position.index, _x.plan_position.distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.relative_pose is None:
        self.relative_pose = geometry_msgs.msg.Pose()
      if self.plan_position is None:
        self.plan_position = marti_nav_msgs.msg.PlanPosition()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.plan_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.plan_id = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.relative_pose.position.x, _x.relative_pose.position.y, _x.relative_pose.position.z, _x.relative_pose.orientation.x, _x.relative_pose.orientation.y, _x.relative_pose.orientation.z, _x.relative_pose.orientation.w, _x.plan_position.index, _x.plan_position.distance,) = _get_struct_7dQd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.plan_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dQd().pack(_x.relative_pose.position.x, _x.relative_pose.position.y, _x.relative_pose.position.z, _x.relative_pose.orientation.x, _x.relative_pose.orientation.y, _x.relative_pose.orientation.z, _x.relative_pose.orientation.w, _x.plan_position.index, _x.plan_position.distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.relative_pose is None:
        self.relative_pose = geometry_msgs.msg.Pose()
      if self.plan_position is None:
        self.plan_position = marti_nav_msgs.msg.PlanPosition()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.plan_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.plan_id = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.relative_pose.position.x, _x.relative_pose.position.y, _x.relative_pose.position.z, _x.relative_pose.orientation.x, _x.relative_pose.orientation.y, _x.relative_pose.orientation.z, _x.relative_pose.orientation.w, _x.plan_position.index, _x.plan_position.distance,) = _get_struct_7dQd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_7dQd = None
def _get_struct_7dQd():
    global _struct_7dQd
    if _struct_7dQd is None:
        _struct_7dQd = struct.Struct("<7dQd")
    return _struct_7dQd
