// Auto-generated. Do not edit!

// (in-package marti_nav_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class VehicleParameters {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.max_curvature = null;
      this.min_curvature = null;
      this.max_lateral_acceleration = null;
      this.target_lateral_acceleration = null;
      this.max_acceleration = null;
      this.target_acceleration = null;
      this.max_deceleration = null;
      this.target_deceleration = null;
      this.stop_deceleration = null;
    }
    else {
      if (initObj.hasOwnProperty('max_curvature')) {
        this.max_curvature = initObj.max_curvature
      }
      else {
        this.max_curvature = 0.0;
      }
      if (initObj.hasOwnProperty('min_curvature')) {
        this.min_curvature = initObj.min_curvature
      }
      else {
        this.min_curvature = 0.0;
      }
      if (initObj.hasOwnProperty('max_lateral_acceleration')) {
        this.max_lateral_acceleration = initObj.max_lateral_acceleration
      }
      else {
        this.max_lateral_acceleration = 0.0;
      }
      if (initObj.hasOwnProperty('target_lateral_acceleration')) {
        this.target_lateral_acceleration = initObj.target_lateral_acceleration
      }
      else {
        this.target_lateral_acceleration = 0.0;
      }
      if (initObj.hasOwnProperty('max_acceleration')) {
        this.max_acceleration = initObj.max_acceleration
      }
      else {
        this.max_acceleration = 0.0;
      }
      if (initObj.hasOwnProperty('target_acceleration')) {
        this.target_acceleration = initObj.target_acceleration
      }
      else {
        this.target_acceleration = 0.0;
      }
      if (initObj.hasOwnProperty('max_deceleration')) {
        this.max_deceleration = initObj.max_deceleration
      }
      else {
        this.max_deceleration = 0.0;
      }
      if (initObj.hasOwnProperty('target_deceleration')) {
        this.target_deceleration = initObj.target_deceleration
      }
      else {
        this.target_deceleration = 0.0;
      }
      if (initObj.hasOwnProperty('stop_deceleration')) {
        this.stop_deceleration = initObj.stop_deceleration
      }
      else {
        this.stop_deceleration = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VehicleParameters
    // Serialize message field [max_curvature]
    bufferOffset = _serializer.float32(obj.max_curvature, buffer, bufferOffset);
    // Serialize message field [min_curvature]
    bufferOffset = _serializer.float32(obj.min_curvature, buffer, bufferOffset);
    // Serialize message field [max_lateral_acceleration]
    bufferOffset = _serializer.float32(obj.max_lateral_acceleration, buffer, bufferOffset);
    // Serialize message field [target_lateral_acceleration]
    bufferOffset = _serializer.float32(obj.target_lateral_acceleration, buffer, bufferOffset);
    // Serialize message field [max_acceleration]
    bufferOffset = _serializer.float32(obj.max_acceleration, buffer, bufferOffset);
    // Serialize message field [target_acceleration]
    bufferOffset = _serializer.float32(obj.target_acceleration, buffer, bufferOffset);
    // Serialize message field [max_deceleration]
    bufferOffset = _serializer.float32(obj.max_deceleration, buffer, bufferOffset);
    // Serialize message field [target_deceleration]
    bufferOffset = _serializer.float32(obj.target_deceleration, buffer, bufferOffset);
    // Serialize message field [stop_deceleration]
    bufferOffset = _serializer.float32(obj.stop_deceleration, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VehicleParameters
    let len;
    let data = new VehicleParameters(null);
    // Deserialize message field [max_curvature]
    data.max_curvature = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [min_curvature]
    data.min_curvature = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [max_lateral_acceleration]
    data.max_lateral_acceleration = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [target_lateral_acceleration]
    data.target_lateral_acceleration = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [max_acceleration]
    data.max_acceleration = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [target_acceleration]
    data.target_acceleration = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [max_deceleration]
    data.max_deceleration = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [target_deceleration]
    data.target_deceleration = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [stop_deceleration]
    data.stop_deceleration = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 36;
  }

  static datatype() {
    // Returns string type for a message object
    return 'marti_nav_msgs/VehicleParameters';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f32b5011f4c0796a9b5689959dcf384a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Set of parameters that describe the motion parameters of a vehicle
    
    # Vehicle's maximum curvature in 1/meters. Should be positive.
    float32 max_curvature
    
    # Vehicle's minimum curvature in 1/meters. Should be negative
    float32 min_curvature
    
    # Vehicle's maximum allowed lateral acceleration in m/s^2
    float32 max_lateral_acceleration
    
    # Vehicle's target lateral acceleration in m/s^2. May be exceeded by vehicle
    float32 target_lateral_acceleration
    
    # Vehicle's maximum allowed linear acceleration in m/s^2
    float32 max_acceleration
    
    # Vehicle's target linear acceleration in m/s^2
    float32 target_acceleration
    
    # Vehicle's maximum linear deceleration in m/s^s. May be exceeded by vehicle
    float32 max_deceleration
    
    # Vehicle's target linear deceleration in m/s^2
    float32 target_deceleration
    
    # Vehicle's linear acceleration in m/s^2 when stopping at the end of a path segment
    float32 stop_deceleration
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VehicleParameters(null);
    if (msg.max_curvature !== undefined) {
      resolved.max_curvature = msg.max_curvature;
    }
    else {
      resolved.max_curvature = 0.0
    }

    if (msg.min_curvature !== undefined) {
      resolved.min_curvature = msg.min_curvature;
    }
    else {
      resolved.min_curvature = 0.0
    }

    if (msg.max_lateral_acceleration !== undefined) {
      resolved.max_lateral_acceleration = msg.max_lateral_acceleration;
    }
    else {
      resolved.max_lateral_acceleration = 0.0
    }

    if (msg.target_lateral_acceleration !== undefined) {
      resolved.target_lateral_acceleration = msg.target_lateral_acceleration;
    }
    else {
      resolved.target_lateral_acceleration = 0.0
    }

    if (msg.max_acceleration !== undefined) {
      resolved.max_acceleration = msg.max_acceleration;
    }
    else {
      resolved.max_acceleration = 0.0
    }

    if (msg.target_acceleration !== undefined) {
      resolved.target_acceleration = msg.target_acceleration;
    }
    else {
      resolved.target_acceleration = 0.0
    }

    if (msg.max_deceleration !== undefined) {
      resolved.max_deceleration = msg.max_deceleration;
    }
    else {
      resolved.max_deceleration = 0.0
    }

    if (msg.target_deceleration !== undefined) {
      resolved.target_deceleration = msg.target_deceleration;
    }
    else {
      resolved.target_deceleration = 0.0
    }

    if (msg.stop_deceleration !== undefined) {
      resolved.stop_deceleration = msg.stop_deceleration;
    }
    else {
      resolved.stop_deceleration = 0.0
    }

    return resolved;
    }
};

module.exports = VehicleParameters;
